# Generated by Django 3.2.7 on 2022-05-24 20:54

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import phonenumber_field.modelfields
import students.managers
import students.validators
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('groups', '0007_alter_group_curator'),
        ('auth', '0012_alter_user_first_name_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='CustomUser',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('is_superuser', models.BooleanField(default=False, help_text='Designates that this user has all permissions without explicitly assigning them.', verbose_name='superuser status')),
                ('first_name', models.CharField(blank=True, max_length=150, verbose_name='name')),
                ('last_name', models.CharField(blank=True, max_length=150, verbose_name='surname')),
                ('phone_number', phonenumber_field.modelfields.PhoneNumberField(max_length=128, region=None, unique=True, verbose_name='phone number')),
                ('is_staff', models.BooleanField(default=False, verbose_name='staff status')),
                ('is_active', models.BooleanField(default=True, verbose_name='active')),
                ('date_joined', models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined')),
                ('photo', models.ImageField(upload_to='static/img/user_profile/')),
                ('groups', models.ManyToManyField(blank=True, help_text='The groups this user belongs to. A user will get all permissions granted to each of their groups.', related_name='user_set', related_query_name='user', to='auth.Group', verbose_name='groups')),
                ('user_permissions', models.ManyToManyField(blank=True, help_text='Specific permissions for this user.', related_name='user_set', related_query_name='user', to='auth.Permission', verbose_name='user permissions')),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
            },
            managers=[
                ('objects', students.managers.CustomUserManager()),
            ],
        ),
        migrations.CreateModel(
            name='Student',
            fields=[
                ('first_name', models.CharField(max_length=128, null=True, validators=[django.core.validators.MinLengthValidator(2), students.validators.first_name_validator])),
                ('last_name', models.CharField(max_length=128, null=True, validators=[django.core.validators.MinLengthValidator(2)])),
                ('email', models.EmailField(max_length=128)),
                ('birthdate', models.DateField(null=True)),
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True)),
                ('grade', models.SmallIntegerField(default=0, null=True)),
                ('avatar', models.ImageField(null=True, upload_to='static/img/avatars/')),
                ('resume', models.FileField(null=True, upload_to='static/uploads/files/', validators=[django.core.validators.FileExtensionValidator(allowed_extensions=['pdf'])])),
                ('group', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='groups.group')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Profile',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('birthdate', models.DateField(blank=True, null=True)),
                ('photo', models.ImageField(upload_to='static/img/user_profiles/')),
                ('phone_number', models.CharField(max_length=16)),
                ('sex', models.CharField(max_length=7)),
                ('user_type', models.CharField(choices=[('Student', 'Student'), ('Teacher', 'Teacher'), ('Mentor', 'Mentor')], max_length=100)),
                ('bio', models.TextField(default='')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='NewStudentInvitation',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True)),
                ('invitation_email_address', models.EmailField(max_length=128)),
                ('invitation_used', models.BooleanField(default=False)),
                ('inviter', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='students.student')),
            ],
        ),
        migrations.CreateModel(
            name='ProxyUser',
            fields=[
            ],
            options={
                'ordering': ('first_name',),
                'proxy': True,
                'indexes': [],
                'constraints': [],
            },
            bases=('students.customuser',),
            managers=[
                ('objects', students.managers.CustomUserManager()),
            ],
        ),
    ]
